#include "mrfi.h"
#include "serial/serial.h"
#define msg_ON  0x01

void main (void)
{	WDTCTL = WDTPW+WDTHOLD;                   // Stop watchdog timer
	P1OUT  = BIT0;				// P1.0 input+pullup
    P1REN |= BIT0;				// P1.0 input+pullup
    P1IE  |= BIT0;				// P1.0 interrupt enable
    P1IES |= BIT0;				// P1.0 Hi/Lo edge
    P1IFG &= ~BIT0;				// P1.0 IFG Flag cleared

	BSP_Init();
	MRFI_Init();				// Init SPI com with CC2500
	MRFI_WakeUp();				// wake up the radio
	MRFI_RxOn(); 				// turn into Rx mode

	initSerial();				// init Serial interface
	printf("\r\n\r\n!!!      app start      !!!\r\n\r\n");

	__bis_SR_register(LPM0_bits + GIE);    // Enter LPM0, interrupts enabled
}

void MRFI_RxCompleteISR_new()	// in Components/mrfi/radios/family5/mrfi_radio.c
{	printf("RX ISR\r\n");
	mrfiPacket_t packetreceived;
	MRFI_Receive(&packetreceived);

	if (packetreceived.frame[5]==msg_ON)
		printf("received msg_ON\r\n");
}

#pragma vector=PORT1_VECTOR
__interrupt void Port_1(void)
{	P1IFG &= ~BIT0;				// P1.0 IFG Flag cleared
	mrfiPacket_t packet;
	packet.frame[0]=0x14;
	packet.frame[5]=msg_ON;
	while(MRFI_TX_RESULT_SUCCESS!=MRFI_Transmit(&packet, MRFI_TX_TYPE_FORCED));
	printf("send msg_ON");
}


